/*
 * Copyright (C) 2012 - Juan Ferrer Toribio
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef SQL_FUNCTION_H
#define SQL_FUNCTION_H

#include "sql-expr.h"

#define SQL_TYPE_FUNCTION		(sql_function_get_type ())
#define SQL_FUNCTION(obj)		(G_TYPE_CHECK_INSTANCE_CAST (obj, SQL_TYPE_FUNCTION, SqlFunction))
#define SQL_IS_FUNCTION(obj)	(G_TYPE_CHECK_INSTANCE_TYPE (obj, SQL_TYPE_FUNCTION))

typedef struct _SqlFunction SqlFunction;
typedef struct _SqlFunctionClass SqlFunctionClass;

/**
 * SqlFunction:
 * @name: name of the called function
 * @param: (element-type Sql.Expr): list of #SqlExpr parameters
 **/
struct _SqlFunction
{
	SqlExpr parent;
	gchar * schema;
	gchar * name;
	SqlList * params;		// List of SqlExpr
};

struct _SqlFunctionClass
{
	/* <private> */
	SqlExprClass parent;
};

GType			sql_function_get_type	();
SqlObject *		sql_function_new 		(const gchar * name, const gchar * schema);

#endif
