/*
 * Copyright (C) 2012 - Juan Ferrer Toribio
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef VN_COMBO_H
#define VN_COMBO_H

#include <vn/vn-field.h>

#define VN_TYPE_COMBO				(vn_combo_get_type ())
#define VN_COMBO(obj)				(G_TYPE_CHECK_INSTANCE_CAST (obj, VN_TYPE_COMBO , VnCombo))
#define VN_IS_COMBO(obj)			(G_TYPE_CHECK_INSTANCE_TYPE (obj, VN_TYPE_COMBO))
#define VN_COMBO_CLASS(klass)		(G_TYPE_CHECK_CLASS_CAST (klass, VN_TYPE_COMBO, VnComboClass))
#define VN_IS_COMBO_CLASS(klass)	(G_TYPE_CHECK_CLASS_TYPE (klass, VN_TYPE_COMBO))
#define VN_COMBO_GET_CLASS(obj)		(G_TYPE_INSTANCE_GET_CLASS (obj, VN_TYPE_COMBO, VnComboClass))

typedef struct _VnCombo VnCombo;
typedef struct _VnComboClass VnComboClass;

struct _VnCombo
{
	VnField parent;
	DbModel * model;
	GtkComboBox * combo;
	GtkCellRenderer * cell;
	GtkTreeModel * tree;
	guint show_column;
	guint index_column;
};

struct _VnComboClass
{
	/* <private> */
	VnFieldClass parent;
};

GType		vn_combo_get_type			();
VnField *	vn_combo_new				(DbModel * model);
VnField *	vn_combo_new_with_sql		(DbConn * conn, const gchar * sql);
void		vn_combo_set_conn			(VnCombo * obj, DbConn * conn);
void		vn_combo_set_model			(VnCombo * obj, DbModel * model);
guint		vn_combo_get_index_column	(VnCombo * obj);
void		vn_combo_set_index_column	(VnCombo * obj, guint column);
guint		vn_combo_get_show_column	(VnCombo * obj);
void		vn_combo_set_show_column	(VnCombo * obj, guint column);

#endif