/*
 * Copyright (C) 2012 - Juan Ferrer Toribio
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef VN_BUILDER_H
#define VN_BUILDER_H

#include <db/db.h>
#include <gtk/gtk.h>
#include "vn-column.h"

#define VN_TYPE_BUILDER				(vn_builder_get_type ())
#define VN_BUILDER(obj)				(G_TYPE_CHECK_INSTANCE_CAST (obj, VN_TYPE_BUILDER, VnBuilder))
#define VN_IS_BUILDER(obj)			(G_TYPE_CHECK_INSTANCE_TYPE (obj, VN_TYPE_BUILDER))
#define VN_BUILDER_CLASS(klass)		(G_TYPE_CHECK_CLASS_CAST (klass, VN_TYPE_BUILDER, VnBuilderClass))
#define VN_IS_BUILDER_CLASS(klass)  (G_TYPE_CHECK_CLASS_TYPE (klass, VN_TYPE_BUILDER))
#define VN_BUILDER_GET_CLASS(obj)   (G_TYPE_INSTANCE_GET_CLASS (obj, VN_TYPE_BUILDER, VnBuilderClass))

#define vn_builder_get(obj,name)	((gpointer) gtk_builder_get_object (GTK_BUILDER (obj), name))

typedef struct _VnBuilder VnBuilder;
typedef struct _VnBuilderClass VnBuilderClass;

struct _VnBuilder
{
	GtkBuilder parent;
};

struct _VnBuilderClass
{
	/* <private> */
	GtkBuilderClass parent;
};

GType		vn_builder_get_type		();
VnBuilder *	vn_builder_new			();
guint		vn_builder_load_file	(VnBuilder * obj, DbConn * conn, const gchar * filename, GError ** err);
void		vn_builder_bind_fields	(VnBuilder * obj, DbIterator * iterator, ...);
void		vn_builder_bind_columns	(VnBuilder * obj, ...);

#endif