/*
 * Copyright (C) 2012 - Juan Ferrer Toribio
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef VN_MODEL_H
#define VN_MODEL_H

#include <glib-object.h>
#include <db/db-model.h>
#include <gtk/gtk.h>

#define VN_TYPE_MODEL           	(vn_model_get_type())
#define VN_MODEL(obj)				(G_TYPE_CHECK_INSTANCE_CAST ((obj), VN_TYPE_MODEL, VnModel))
#define VN_IS_MODEL(obj)       		(G_TYPE_CHECK_INSTANCE_TYPE ((obj), VN_TYPE_MODEL))
#define VN_MODEL_CLASS(klass)   	(G_TYPE_CHECK_CLASS_CAST ((klass), VN_TYPE_MODEL, VnModelClass))
#define VN_IS_MODEL_CLASS(klass)	(G_TYPE_CHECK_CLASS_TYPE ((klass), VN_TYPE_MODEL))
#define VN_MODEL_GET_CLASS(obj)		(G_TYPE_INSTANCE_GET_CLASS ((obj), VN_TYPE_MODEL, VnModelClass))

#define VN_MODEL_LOG_DOMAIN		(g_quark_from_string ("VnModel"))

#define gtk_tree_iter_from_db_iter(d,s)	vn_gtk_tree_iter_from_db_iter(d,s)
#define gtk_tree_iter_to_db_iter(s,d)	vn_gtk_tree_iter_to_db_iter(s,d)

typedef struct _VnModel VnModel;
typedef struct _VnModelClass VnModelClass;

struct _VnModel
{
	GObject parent;
	DbModel * model;
};

struct _VnModelClass
{
	/* <private> */
	GObjectClass parent;
};

GType			vn_model_get_type				();
VnModel *		vn_model_new					(DbModel * model);
gboolean		vn_model_iter_is_valid			(GtkTreeIter * iter, GtkTreeModel * model);
void			vn_gtk_tree_iter_from_db_iter	(GtkTreeIter * dest_iter
												,const DbIter * src_iter);
void			vn_gtk_tree_iter_to_db_iter		(const GtkTreeIter * src_iter
												,DbIter * dest_iter);

#endif